#include "killlog.h"

LOG* pLog;
PPVERT* pPVert;
char* pPHead;
KILLSTATE* pPHealth;
KILLSTATE* pVHealth;

BOOL APIENTRY DllMain(HMODULE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		DLLInit();
		break;
	case DLL_THREAD_ATTACH:
		break;
	case DLL_THREAD_DETACH:
		break;
	case DLL_PROCESS_DETACH:
		DLLExit();
		break;
	}

	return TRUE;
}

void DLLInit()
{
	char cPath[MAX_PATH];
	char cBuffer[64];
	char cModel[16];
	FILE* file;
	char* pCurrent;
	char* pOldSep;
	int dwCurrentRule;

	GetModuleFileName(NULL, cPath, MAX_PATH);
	if (strrchr(cPath, '\\')) *(char*)(strrchr(cPath, '\\') + 1) = '\0';
	strcat_s(cPath, MAX_PATH, "killlog.ini");
	if (fopen_s(&file, cPath, "rt"))
	{
		MessageBox(0, "killlog.ini", "File Not Found", MB_OK | MB_ICONERROR);
		ExitProcess(0);
	}
	fclose(file);

	KillConfig.KillLog.Suicide = GetPrivateProfileInt("KILLLOG", "Suicide", 1, cPath);
	KillConfig.KillLog.MaxLog = GetPrivateProfileInt("KILLLOG", "MaxLog", 8, cPath);
	KillConfig.KillLog.LogTime = GetPrivateProfileInt("KILLLOG", "LogTime", 5000, cPath);
	KillConfig.KillLog.ShowPedDeath = GetPrivateProfileInt("KILLLOG", "ShowPedDeath", 1, cPath);
	KillConfig.KillLog.ShowVehicleDeath = GetPrivateProfileInt("KILLLOG", "ShowVehicleDeath", 1, cPath);
	GetPrivateProfileString("KILLLOG", "NameConfig", "killlog_name.dat", KillConfig.KillLog.NameConfig, MAX_PATH, cPath);
	GetPrivateProfileString("KILLLOG", "IconConfig", "killlog_icon.dat", KillConfig.KillLog.IconConfig, MAX_PATH, cPath);

	KillConfig.Font.FontSize = GetPrivateProfileInt("FONT", "FontSize", -9, cPath);
	KillConfig.Font.FontWeight = GetPrivateProfileInt("FONT", "FontWeight", 800, cPath);
	GetPrivateProfileString("FONT", "FontFace", "Arial", KillConfig.Font.FontFace, 64, cPath);

	GetPrivateProfileString("POSITION", "PositionX", "608.0", cBuffer, 64, cPath);
	KillConfig.Position.PositionX = (float)atof(cBuffer) / 640.f;
	GetPrivateProfileString("POSITION", "PositionY", "144.0", cBuffer, 64, cPath);
	KillConfig.Position.PositionY = (float)atof(cBuffer) / 480.f;
	GetPrivateProfileString("POSITION", "Height", "24.0", cBuffer, 64, cPath);
	KillConfig.Position.Height = (float)atof(cBuffer) / 480.f;
	KillConfig.Position.AlignH = GetPrivateProfileInt("POSITION", "AlignH", 1, cPath);
	KillConfig.Position.AlignV = GetPrivateProfileInt("POSITION", "AlignV", 1, cPath);

	GetPrivateProfileString("ICON", "IconFile", "killlog.png", KillConfig.Icon.IconFile, MAX_PATH, cPath);
	KillConfig.Icon.IconSBlend = (D3DBLEND)GetPrivateProfileInt("ICON", "IconSBlend", D3DBLEND_ONE, cPath);
	KillConfig.Icon.IconDBlend = (D3DBLEND)GetPrivateProfileInt("ICON", "IconDBlend", D3DBLEND_ONE, cPath);
	KillConfig.Icon.IconBlendO = (D3DBLENDOP)GetPrivateProfileInt("ICON", "IconBlendO", D3DBLENDOP_ADD, cPath);
	GetPrivateProfileString("ICON", "IconSize", "24.0", cBuffer, 64, cPath);
	KillConfig.Icon.IconSize = (float)atof(cBuffer) / 480.f;

	KillConfig.NameConv.KDriver = GetPrivateProfileInt("NAMECONV", "KDriver", 1, cPath);
	KillConfig.NameConv.KVehicle = GetPrivateProfileInt("NAMECONV", "KVehicle", 3, cPath);
	KillConfig.NameConv.VDriver = GetPrivateProfileInt("NAMECONV", "VDriver", 1, cPath);
	KillConfig.NameConv.VVehicle = GetPrivateProfileInt("NAMECONV", "VVehicle", 0, cPath);

	GetModuleFileName(NULL, cPath, MAX_PATH);
	if (strrchr(cPath, '\\')) *(char*)(strrchr(cPath, '\\') + 1) = '\0';
	strcat_s(cPath, MAX_PATH, KillConfig.KillLog.NameConfig);
	if (fopen_s(&file, cPath, "rt"))
	{
		MessageBox(0, KillConfig.KillLog.NameConfig, "File Not Found", MB_OK | MB_ICONERROR);
		ExitProcess(0);
	}
	while (true)
	{
		fgets(cBuffer, 1024, file);
		if (cBuffer[0] == ';') continue;
		if (cBuffer[0] == '\0') break;
		if (feof(file)) break;
		KillConfig.NameRuleNum++;
	}
	KillConfig.NameRule = (NAMERULE*)calloc(KillConfig.NameRuleNum, sizeof(NAMERULE));
	KillConfig.NameRuleString = (char*)malloc(512);
	pCurrent = KillConfig.NameRuleString;
	pOldSep = pCurrent + 256;
	dwCurrentRule = 0;
	fseek(file, 0, SEEK_SET);
	while (true)
	{
		fgets(cBuffer, 1024, file);
		if (cBuffer[0] == ';') continue;
		if (cBuffer[0] == '\0') break;
		if (feof(file)) break;
		sscanf_s(cBuffer, "%d %s %x %[^\n]", &KillConfig.NameRule[dwCurrentRule].PedType, cModel, 16, &KillConfig.NameRule[dwCurrentRule].Color, pCurrent, 256);
		KillConfig.NameRule[dwCurrentRule].ModelID = 0;
		for (int i = 0; i < (signed)strlen(cModel); i++)
		{
			if ('0' <= cModel[i] && cModel[i] <= '9') continue;
			if ('-' == cModel[i]) continue;
			_strupr_s(cModel, 16);
			KillConfig.NameRule[dwCurrentRule].ModelID = ~crc(cModel, strlen(cModel));
			break;
		}
		if (!KillConfig.NameRule[dwCurrentRule].ModelID) KillConfig.NameRule[dwCurrentRule].ModelID = atoi(cModel);
		KillConfig.NameRule[dwCurrentRule].Name = pCurrent;
		pCurrent += strlen(pCurrent) + 1;
		dwCurrentRule++;
		if (pCurrent > pOldSep)
		{
			for (int i = 0; i < dwCurrentRule; i++) KillConfig.NameRule[i].Name -= (unsigned long)KillConfig.NameRuleString;
			pCurrent -= (unsigned long)KillConfig.NameRuleString;
			pOldSep -= (unsigned long)KillConfig.NameRuleString;
			KillConfig.NameRuleString = (char*)realloc(KillConfig.NameRuleString, (unsigned long)pOldSep + 512);
			for (int i = 0; i < dwCurrentRule; i++) KillConfig.NameRule[i].Name += (unsigned long)KillConfig.NameRuleString;
			pCurrent += (unsigned long)KillConfig.NameRuleString;
			pOldSep += (unsigned long)KillConfig.NameRuleString + 256;
		}
	}
	fclose(file);

	GetModuleFileName(NULL, cPath, MAX_PATH);
	if (strrchr(cPath, '\\')) *(char*)(strrchr(cPath, '\\') + 1) = '\0';
	strcat_s(cPath, MAX_PATH, KillConfig.KillLog.IconConfig);
	if (fopen_s(&file, cPath, "rt"))
	{
		MessageBox(0, KillConfig.KillLog.IconConfig, "File Not Found", MB_OK | MB_ICONERROR);
		ExitProcess(0);
	}
	for (int i = 0; i < 8; i++)
	{
		fgets(cBuffer, 1024, file);
		sscanf_s(cBuffer, "%d %d %d %d %d %d %d %d", &KillConfig.IconWidth[i * 8], &KillConfig.IconWidth[i * 8 + 1], &KillConfig.IconWidth[i * 8 + 2], &KillConfig.IconWidth[i * 8 + 3], &KillConfig.IconWidth[i * 8 + 4], &KillConfig.IconWidth[i * 8 + 5], &KillConfig.IconWidth[i * 8 + 6], &KillConfig.IconWidth[i * 8 + 7]);
	}
	fclose(file);

	pLog = (LOG*)calloc(KillConfig.KillLog.MaxLog, sizeof(LOG));
	pPVert = (PPVERT*)calloc(KillConfig.KillLog.MaxLog * 4, sizeof(PPVERT));

	const unsigned char cJump = 0xE9;
	const unsigned char cCall = 0xE8;
	unsigned long pFunc;

	if (check((void*)0x7F8704, 0x68, "IDirect3DDevice9::Reset", true))
	{
		pFunc = (unsigned long)&Change3D - 0x7F8709;
		patch(0x7F8704, &cCall, 1);
		patch(0x7F8705, &pFunc, 4);
		nop(0x7F8709, 4);
	} else
	if (check((void*)0x7F86C4, 0x68, "IDirect3DDevice9::Reset", true))
	{
		pFunc = (unsigned long)&Change3D - 0x7F86C9;
		patch(0x7F86C4, &cCall, 1);
		patch(0x7F86C5, &pFunc, 4);
		nop(0x7F86C9, 4);
	} else
	if (check((void*)0x7F8704, 0xE8, "IDirect3DDevice9::Reset", true))
	{
		pFunc = (unsigned long)&Change3D - 0x7F8709;
		dwChange3DCall = *(long*)0x7F8705 + 0x7F8709;
		patch(0x7F8704, &cCall, 1);
		patch(0x7F8705, &pFunc, 4);
		nop(0x7F8709, 4);
	} else
	if (check((void*)0x7F86C4, 0xE8, "IDirect3DDevice9::Reset", false))
	{
		pFunc = (unsigned long)&Change3D - 0x7F86C9;
		dwChange3DCall = *(long*)0x7F86C5 + 0x7F86C9;
		patch(0x7F86C4, &cCall, 1);
		patch(0x7F86C5, &pFunc, 4);
		nop(0x7F86C9, 4);
	}

	if (check((void*)0x7F9750, 0x68, "IDirect3DDevice9::Reset", true))
	{
		pFunc = (unsigned long)&Reset3D - 0x7F9755;
		patch(0x7F9750, &cCall, 1);
		patch(0x7F9751, &pFunc, 4);
		nop(0x7F9755, 6);
	} else
	if (check((void*)0x7F9710, 0x68, "IDirect3DDevice9::Reset", true))
	{
		pFunc = (unsigned long)&Reset3D - 0x7F9715;
		patch(0x7F9710, &cCall, 1);
		patch(0x7F9711, &pFunc, 4);
		nop(0x7F9715, 6);
	} else
	if (check((void*)0x7F9750, 0xE8, "IDirect3DDevice9::Reset", true))
	{
		pFunc = (unsigned long)&Reset3D - 0x7F9755;
		dwReset3DCall = *(long*)0x7F9751 + 0x7F9755;
		patch(0x7F9750, &cCall, 1);
		patch(0x7F9751, &pFunc, 4);
		nop(0x7F9755, 6);
	} else
	if (check((void*)0x7F9710, 0xE8, "IDirect3DDevice9::Reset", false))
	{
		pFunc = (unsigned long)&Reset3D - 0x7F9715;
		dwReset3DCall = *(long*)0x7F9711 + 0x7F9715;
		patch(0x7F9710, &cCall, 1);
		patch(0x7F9711, &pFunc, 4);
		nop(0x7F9715, 6);
	}

	if (check((void*)0x7F97C8, 0x68, "IDirect3DDevice9::Reset", true))
	{
		pFunc = (unsigned long)&Reset3D - 0x7F97CD;
		patch(0x7F97C8, &cCall, 1);
		patch(0x7F97C9, &pFunc, 4);
		nop(0x7F97CD, 6);
	} else
	if (check((void*)0x7F9788, 0x68, "IDirect3DDevice9::Reset", true))
	{
		pFunc = (unsigned long)&Reset3D - 0x7F978D;
		patch(0x7F9788, &cCall, 1);
		patch(0x7F9789, &pFunc, 4);
		nop(0x7F978D, 6);
	} else
	if (check((void*)0x7F97C8, 0xE8, "IDirect3DDevice9::Reset", true))
	{
		pFunc = (unsigned long)&Reset3D - 0x7F97CD;
		dwReset3DCall = *(long*)0x7F97C9 + 0x7F97CD;
		patch(0x7F97C8, &cCall, 1);
		patch(0x7F97C9, &pFunc, 4);
		nop(0x7F97CD, 6);
	} else
	if (check((void*)0x7F9788, 0xE8, "IDirect3DDevice9::Reset", false))
	{
		pFunc = (unsigned long)&Reset3D - 0x7F978D;
		dwReset3DCall = *(long*)0x7F9789 + 0x7F978D;
		patch(0x7F9788, &cCall, 1);
		patch(0x7F9789, &pFunc, 4);
		nop(0x7F978D, 6);
	}

	if (check((void*)0x7F9A56, 0x68, "IDirect3DDevice9::Reset", true))
	{
		pFunc = (unsigned long)&Reset3D - 0x7F9A5B;
		patch(0x7F9A56, &cCall, 1);
		patch(0x7F9A57, &pFunc, 4);
		nop(0x7F9A5B, 6);
	} else
	if (check((void*)0x7F9A16, 0x68, "IDirect3DDevice9::Reset", true))
	{
		pFunc = (unsigned long)&Reset3D - 0x7F9A1B;
		patch(0x7F9A16, &cCall, 1);
		patch(0x7F9A17, &pFunc, 4);
		nop(0x7F9A1B, 6);
	} else
	if (check((void*)0x7F9A56, 0xE8, "IDirect3DDevice9::Reset", true))
	{
		pFunc = (unsigned long)&Reset3D - 0x7F9A5B;
		dwReset3DCall = *(long*)0x7F9A57 + 0x7F9A5B;
		patch(0x7F9A56, &cCall, 1);
		patch(0x7F9A57, &pFunc, 4);
		nop(0x7F9A5B, 6);
	} else
	if (check((void*)0x7F9A16, 0xE8, "IDirect3DDevice9::Reset", false))
	{
		pFunc = (unsigned long)&Reset3D - 0x7F9A1B;
		dwReset3DCall = *(long*)0x7F9A17 + 0x7F9A1B;
		patch(0x7F9A16, &cCall, 1);
		patch(0x7F9A17, &pFunc, 4);
		nop(0x7F9A1B, 6);
	}

	if (check((void*)0x704F61, 0xE8, "DrawInterface", true))
	{
		dwRenderCall = *(long*)0x704F62 + 0x704F66;
		pFunc = (unsigned long)&Render - 0x704F66;
		patch(0x704F61, &cCall, 1);
		patch(0x704F62, &pFunc, 4);
	} else
	if (check((void*)0x704F61, 0xA0, "DrawInterface", false))
	{
		pFunc = (unsigned long)&Render - 0x704F66;
		patch(0x704F61, &cCall, 1);
		patch(0x704F62, &pFunc, 4);
	}

	if (check((void*)0x4B3395 , 0x89, "HeadShot", false))
	{
		pFunc = (unsigned long)&HeadShot - 0x4B339A;
		patch(0x4B3395, &cJump, 1);
		patch(0x4B3396, &pFunc, 4);
	}

	if (check((void*)0x5E6592, 0xE8, "_GetWeaponSkill", false)) _GetWeaponSkill = (char (__fastcall *)(void*, void*, long))(*(long*)0x5E6593 + 0x5E6597);
	if (check((void*)0x7330A9, 0xE8, "_GetWeaponData", false)) _GetWeaponData = (long* (__cdecl *)(long, char))(*(long*)0x7330AA + 0x7330AE);

	return;
}

void DLLExit()
{
	DestResource();

	SAFE_FREE(KillConfig.NameRule);
	SAFE_FREE(KillConfig.NameRuleString);
	SAFE_FREE(pLog);
	SAFE_FREE(pPVert);
	SAFE_FREE(pPHead);
	SAFE_FREE(pPHealth);
	SAFE_FREE(pVHealth);

	return;
}


void InitResource()
{
	IDirect3DDevice9* pD3DDev = *(IDirect3DDevice9**)0xC97C28;
	D3DSURFACE_DESC desc;
	(*(IDirect3DSurface9**)0xC97C30)->GetDesc(&desc);

	if (!pPHead) pPHead = (char*)calloc(((long**)0xB74490)[0][2], sizeof(char));
	if (!pPHealth) pPHealth = (KILLSTATE*)calloc(((long**)0xB74490)[0][2], sizeof(KILLSTATE));
	if (!pVHealth) pVHealth = (KILLSTATE*)calloc(((long**)0xB74494)[0][2], sizeof(KILLSTATE));

	for (int i = 0; i < KillConfig.KillLog.MaxLog; i++)
	{
		pPVert[i * 4 + 0].y = pPVert[i * 4 + 1].y = (((float)i + .5f) * KillConfig.Position.Height * (float)KillConfig.Position.AlignV - KillConfig.Icon.IconSize * .5f + KillConfig.Position.PositionY) * (float)desc.Height;
		pPVert[i * 4 + 2].y = pPVert[i * 4 + 3].y = (((float)i + .5f) * KillConfig.Position.Height * (float)KillConfig.Position.AlignV + KillConfig.Icon.IconSize * .5f + KillConfig.Position.PositionY) * (float)desc.Height;
		pPVert[i * 4 + 0].z = pPVert[i * 4 + 1].z = pPVert[i * 4 + 2].z = pPVert[i * 4 + 3].z = 0.f;
		pPVert[i * 4 + 0].w = pPVert[i * 4 + 1].w = pPVert[i * 4 + 2].w = pPVert[i * 4 + 3].w = 1.f;
		pPVert[i * 4 + 0].c = pPVert[i * 4 + 1].c = pPVert[i * 4 + 2].c = pPVert[i * 4 + 3].c = 0xFFFFFFFF;
	}

	if (!pLogFont)
	{
		D3DXCreateFont(pD3DDev, (KillConfig.Font.FontSize < 0) ? -KillConfig.Font.FontSize * desc.Width / 640 : KillConfig.Font.FontSize, 0, KillConfig.Font.FontWeight, 1, FALSE, DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_SWISS, strlen(KillConfig.Font.FontFace) ? KillConfig.Font.FontFace : NULL, &pLogFont);
		pLogFont->PreloadText("in", strlen("in"));
		for (int i = 0; i < KillConfig.NameRuleNum; i++)
		{
			pLogFont->PreloadText(KillConfig.NameRule[i].Name, strlen(KillConfig.NameRule[i].Name));
		}
	}

	if (!pIconTexture)
	{
		char cPath[MAX_PATH];
		GetModuleFileName(NULL, cPath, MAX_PATH);
		if (strrchr(cPath, '\\')) *(char*)(strrchr(cPath, '\\') + 1) = '\0';
		strcat_s(cPath, MAX_PATH, KillConfig.Icon.IconFile);
		HRESULT hr;
		hr = D3DXCreateTextureFromFile(pD3DDev, cPath, &pIconTexture);
		IDirect3DSurface9* pSurface;
		pIconTexture->GetSurfaceLevel(0, &pSurface);
		pSurface->GetDesc(&desc);
		pSurface->Release();
		dwIconWidth = desc.Width / 8;
		dwIconHeight = desc.Height / 8;
	}

	return;
}

void DestResource()
{
	SAFE_RELEASE(pIconTexture);
	SAFE_RELEASE(pLogFont);

	return;
}

void __declspec(naked) Change3D()
{
	__asm
	{
		pushad;
		call DestResource;
		popad;
		test dwChange3DCall, 0xFFFFFFFF;
		jz CALL_REAL;
		mov edi, dwChange3DCall
		call edi;
		jmp CALL_END;

CALL_REAL:
		push 0xC9C040;
		push eax;
		call [ecx+0x40];

CALL_END:
		ret;
	}
}

void __declspec(naked) Reset3D()
{
	__asm
	{
		pushad;
		call DestResource;
		popad;
		test dwReset3DCall, 0xFFFFFFFF;
		jz CALL_REAL;
		mov edi, dwReset3DCall
		call edi;
		jmp CALL_END;

CALL_REAL:
		push 0xC9C040;
		push eax;
		mov edx, [eax];
		call [edx+0x40];

CALL_END:
		ret;
	}
}

char Render()
{
	IDirect3DDevice9* pD3DDev = *(IDirect3DDevice9**)0xC97C28;
	D3DSURFACE_DESC desc;
	(*(IDirect3DSurface9**)0xC97C30)->GetDesc(&desc);

	IDirect3DSurface9* pOldRTarget;
	IDirect3DBaseTexture9* pOldTexture;
	DWORD dwFVF;
	IDirect3DVertexDeclaration9* pVDecl;
	DWORD dwZEnable;
	DWORD dwZWrite;
	DWORD dwSBlend;
	DWORD dwDBlend;
	DWORD dwZFunc;
	DWORD dwCull;
	DWORD dwBlendOp;
	IDirect3DVertexBuffer9* pSSData;
	UINT dwSSOffset;
	UINT dwSSSize;
	DWORD tfMag;
	DWORD tfMin;
	DWORD tfMip;
	DWORD ssAdU;
	DWORD ssAdV;

	InitResource();

	pD3DDev->GetRenderTarget(0, &pOldRTarget);
	pD3DDev->GetTexture(0, &pOldTexture);
	pD3DDev->GetFVF(&dwFVF);
    pD3DDev->GetVertexDeclaration(&pVDecl);
	pD3DDev->GetRenderState(D3DRS_ZENABLE, &dwZEnable);
	pD3DDev->GetRenderState(D3DRS_ZWRITEENABLE, &dwZWrite);
	pD3DDev->GetRenderState(D3DRS_SRCBLEND, &dwSBlend);
	pD3DDev->GetRenderState(D3DRS_DESTBLEND, &dwDBlend);
	pD3DDev->GetRenderState(D3DRS_CULLMODE, &dwCull);
	pD3DDev->GetRenderState(D3DRS_ZFUNC, &dwZFunc);
	pD3DDev->GetRenderState(D3DRS_BLENDOP, &dwBlendOp);
	pD3DDev->GetStreamSource(0, &pSSData, &dwSSOffset, &dwSSSize);
	pD3DDev->GetSamplerState(0, D3DSAMP_MAGFILTER, &tfMag);
	pD3DDev->GetSamplerState(0, D3DSAMP_MINFILTER, &tfMin);
	pD3DDev->GetSamplerState(0, D3DSAMP_MIPFILTER, &tfMip);
	pD3DDev->GetSamplerState(0, D3DSAMP_ADDRESSU, &ssAdU);
	pD3DDev->GetSamplerState(0, D3DSAMP_ADDRESSV, &ssAdV);

	pD3DDev->SetRenderTarget(0, *(IDirect3DSurface9**)0xC97C30);
	pD3DDev->SetFVF(D3DFVF_XYZRHW | D3DFVF_DIFFUSE | D3DFVF_TEX1);
	pD3DDev->SetTexture(0, pIconTexture);
	pD3DDev->SetSamplerState(0, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR);
	pD3DDev->SetSamplerState(0, D3DSAMP_MINFILTER, D3DTEXF_LINEAR);
	pD3DDev->SetSamplerState(0, D3DSAMP_MIPFILTER, D3DTEXF_LINEAR);
	pD3DDev->SetSamplerState(0, D3DSAMP_ADDRESSU, D3DTADDRESS_WRAP);
	pD3DDev->SetSamplerState(0, D3DSAMP_ADDRESSV, D3DTADDRESS_WRAP);

	pD3DDev->SetRenderState(D3DRS_ZENABLE, FALSE);
	pD3DDev->SetRenderState(D3DRS_ZWRITEENABLE, FALSE);
	pD3DDev->SetRenderState(D3DRS_SRCBLEND, KillConfig.Icon.IconSBlend);
	pD3DDev->SetRenderState(D3DRS_DESTBLEND, KillConfig.Icon.IconDBlend);
	pD3DDev->SetRenderState(D3DRS_CULLMODE, D3DCULL_NONE);
	pD3DDev->SetRenderState(D3DRS_ZFUNC, D3DCMP_ALWAYS);
	pD3DDev->SetRenderState(D3DRS_BLENDOP, KillConfig.Icon.IconBlendO);

	if (KillConfig.KillLog.ShowVehicleDeath) for (int i = 0; i < ((long**)0xB74494)[0][2]; i++)
	{
		if (((unsigned char***)0xB74494)[0][1][i] & 0x80)
		{
			pVHealth[i] = KS_NOTUSED;
		} else
		{
			void* pVehicle = (void*)(((unsigned long**)0xB74494)[0][0] + i * 0xA18);
			if (pVHealth[i] == KS_ALIVE && ((float*)pVehicle)[0x130] <= 0.f)
			{
				for (int j = 0; j < KillConfig.KillLog.MaxLog + 1; j++)
				{
					if (j == KillConfig.KillLog.MaxLog)
					{
						for (int k = 0; k < KillConfig.KillLog.MaxLog - 1; k++) memcpy(&pLog[k], &pLog[k + 1], sizeof(LOG));
						j--;
						ZeroMemory(&pLog[j], sizeof(LOG));
					}
					if (pLog[j].dwTime) continue;
					switch (KillConfig.NameConv.VVehicle)
					{
					case 0:
						pLog[j].pVictim = ((char* (__fastcall *)(long, void*, char*))0x6A0050)(0xC1B340, NULL, ((char**)0xA9B0C8)[((unsigned short*)pVehicle)[0x11]] + 50);
						pLog[j].dwVColor = ((unsigned long*)0xB4E480)[((unsigned char*)pVehicle)[0x434]];
						((unsigned char*)&pLog[j].dwVColor)[0] ^= ((unsigned char*)&pLog[j].dwVColor)[2];
						((unsigned char*)&pLog[j].dwVColor)[2] ^= ((unsigned char*)&pLog[j].dwVColor)[0];
						((unsigned char*)&pLog[j].dwVColor)[0] ^= ((unsigned char*)&pLog[j].dwVColor)[2];
						break;
					case 1:
						if (((unsigned long*)pVehicle)[0x118]) GetPedName(((unsigned long**)pVehicle)[0x118][0x166], ((unsigned short**)pVehicle)[0x118][0x11], &pLog[j].pVictim, &pLog[j].dwVColor);
						break;
					case 2:
						if (((unsigned long*)pVehicle)[0x118]) GetPedName(((unsigned long**)pVehicle)[0x118][0x166], ((unsigned short**)pVehicle)[0x118][0x11], &pLog[j].pVictim, &pLog[j].dwVColor);
						if (!((unsigned long*)pVehicle)[0x118]) pLog[j].pVictim = ((char* (__fastcall *)(long, void*, char*))0x6A0050)(0xC1B340, NULL, ((char**)0xA9B0C8)[((unsigned short*)pVehicle)[0x11]] + 50);
						if (!((unsigned long*)pVehicle)[0x118]) pLog[j].dwVColor = ((unsigned long*)0xB4E480)[((unsigned char*)pVehicle)[0x434]];
						break;
					case 3:
						if (((unsigned long*)pVehicle)[0x118]) GetPedName(((unsigned long**)pVehicle)[0x118][0x166], ((unsigned short**)pVehicle)[0x118][0x11], &pLog[j].pVictim, &pLog[j].dwVColor);
						pLog[j].pVictim2 = ((char* (__fastcall *)(long, void*, char*))0x6A0050)(0xC1B340, NULL, ((char**)0xA9B0C8)[((unsigned short*)pVehicle)[0x11]] + 50);
						pLog[j].dwVColor2 = ((unsigned long*)0xB4E480)[((unsigned char*)pVehicle)[0x434]];
						((unsigned char*)&pLog[j].dwVColor2)[0] ^= ((unsigned char*)&pLog[j].dwVColor2)[2];
						((unsigned char*)&pLog[j].dwVColor2)[2] ^= ((unsigned char*)&pLog[j].dwVColor2)[0];
						((unsigned char*)&pLog[j].dwVColor2)[0] ^= ((unsigned char*)&pLog[j].dwVColor2)[2];
						break;
					case 4:
						break;
					}
					pLog[j].dwReason = ((unsigned char*)pVehicle)[0x508];
					if (pLog[j].dwReason > 62) pLog[j].dwReason = 62;
					if (!KillConfig.KillLog.Suicide || pVehicle != ((void**)pVehicle)[0x143]) GetKiller(&pLog[j], ((void**)pVehicle)[0x143]);
					pLog[j].dwTime = *(unsigned long*)0xB7CB84;
					break;
				}
			}
			pVHealth[i] = (((float*)pVehicle)[0x130] > 0.f) ? KS_ALIVE : KS_DEAD;
		}
	}

	if (KillConfig.KillLog.ShowPedDeath) for (int i = 0; i < ((long**)0xB74490)[0][2]; i++)
	{
		if (((unsigned char***)0xB74490)[0][1][i] & 0x80)
		{
			pPHealth[i] = KS_NOTUSED;
			pPHead[i] = 0;
		} else
		{
			void* pPed = (void*)(((unsigned long**)0xB74490)[0][0] + i * 0x7C4);
			if (pPHealth[i] == KS_ALIVE && ((float*)pPed)[0x150] <= 0.f)
			{
				for (int j = 0; j < KillConfig.KillLog.MaxLog + 1; j++)
				{
					if (j == KillConfig.KillLog.MaxLog)
					{
						for (int k = 0; k < KillConfig.KillLog.MaxLog - 1; k++) memcpy(&pLog[k], &pLog[k + 1], sizeof(LOG));
						j--;
						ZeroMemory(&pLog[j], sizeof(LOG));
					}
					if (pLog[j].dwTime) continue;
					GetPedName(((unsigned long*)pPed)[0x166], ((unsigned short*)pPed)[0x11], &pLog[j].pVictim, &pLog[j].dwVColor);
					if (KillConfig.NameConv.VDriver) if (((unsigned long*)pPed)[0x14C] == 50) if (((unsigned long*)pPed)[0x163])
					{
						pLog[j].pVictim2 = ((char* (__fastcall *)(long, void*, char*))0x6A0050)(0xC1B340, NULL, ((char**)0xA9B0C8)[((unsigned short**)pPed)[0x163][0x11]] + 50);
						pLog[j].dwVColor2 = ((unsigned long*)0xB4E480)[((unsigned char**)pPed)[0x163][0x434]];
						((unsigned char*)&pLog[j].dwVColor2)[0] ^= ((unsigned char*)&pLog[j].dwVColor2)[2];
						((unsigned char*)&pLog[j].dwVColor2)[2] ^= ((unsigned char*)&pLog[j].dwVColor2)[0];
						((unsigned char*)&pLog[j].dwVColor2)[0] ^= ((unsigned char*)&pLog[j].dwVColor2)[2];
					}
					pLog[j].dwReason = ((unsigned char*)pPed)[0x760];
					if (pLog[j].dwReason > 62) pLog[j].dwReason = 62;
					if (pPHead[i]) pLog[j].dwReason |= 0x80000000;
					if (!KillConfig.KillLog.Suicide || pPed != ((void**)pPed)[0x1D9]) GetKiller(&pLog[j], ((void**)pPed)[0x1D9]);
					pPHead[i] = 0;
					pLog[j].dwTime = *(unsigned long*)0xB7CB84;
					break;
				}
			}
			pPHealth[i] = (((float*)pPed)[0x150] > 0.f) ? KS_ALIVE : KS_DEAD;
		}
	}

	while (pLog[0].dwTime && *(unsigned long*)0xB7CB84 - pLog[0].dwTime > KillConfig.KillLog.LogTime)
	{
		for (int k = 0; k < KillConfig.KillLog.MaxLog - 1; k++) memcpy(&pLog[k], &pLog[k + 1], sizeof(LOG));
		ZeroMemory(&pLog[KillConfig.KillLog.MaxLog - 1], sizeof(LOG));
	}
	for (int i = 0; i < KillConfig.KillLog.MaxLog; i++)
	{
		if (!pLog[i].dwTime) continue;
		long dwCurrentX;
		RECT rect;
		rect.top = (long)(((float)i * KillConfig.Position.Height * (float)KillConfig.Position.AlignV + KillConfig.Position.PositionY) * (float)desc.Height);
		rect.bottom = (long)(((float)(i + KillConfig.Position.AlignV) * KillConfig.Position.Height * (float)KillConfig.Position.AlignV + KillConfig.Position.PositionY) * (float)desc.Height);
		rect.left = rect.right = 0;
		switch (KillConfig.Position.AlignH)
		{
		case -1:
			{
				dwCurrentX = (long)(KillConfig.Position.PositionX * (float)desc.Width);
				if (pLog[i].pKiller)
				{
					rect.left = rect.right = dwCurrentX;
					pLogFont->DrawText(NULL, pLog[i].pKiller, -1, &rect, DT_VCENTER | DT_SINGLELINE | DT_NOCLIP, pLog[i].dwKColor);
					rect.left = rect.right = 0;
					pLogFont->DrawText(NULL, pLog[i].pKiller, -1, &rect, DT_VCENTER | DT_SINGLELINE | DT_CALCRECT, pLog[i].dwKColor);
					dwCurrentX += rect.right;
				}
				if (pLog[i].pKiller && pLog[i].pKiller2)
				{
					dwCurrentX += desc.Width / 160;
					rect.left = rect.right = dwCurrentX;
					pLogFont->DrawText(NULL, "in", -1, &rect, DT_VCENTER | DT_SINGLELINE | DT_NOCLIP, 0xFFCCCCCC);
					rect.left = rect.right = 0;
					pLogFont->DrawText(NULL, "in", -1, &rect, DT_VCENTER | DT_SINGLELINE | DT_CALCRECT, 0xFFCCCCCC);
					dwCurrentX += rect.right;
					dwCurrentX += desc.Width / 160;
				}
				if (pLog[i].pKiller2)
				{
					rect.left = rect.right = dwCurrentX;
					pLogFont->DrawText(NULL, pLog[i].pKiller2, -1, &rect, DT_VCENTER | DT_SINGLELINE | DT_NOCLIP, pLog[i].dwKColor2);
					rect.left = rect.right = 0;
					pLogFont->DrawText(NULL, pLog[i].pKiller2, -1, &rect, DT_VCENTER | DT_SINGLELINE | DT_CALCRECT, pLog[i].dwKColor2);
					dwCurrentX += rect.right;
				}
				if (pLog[i].dwReason & 0x40000000)
				{
					pPVert[i * 4 + 0].x = pPVert[i * 4 + 2].x = (float)dwCurrentX;
					dwCurrentX += (long)((float)KillConfig.IconWidth[pLog[i].dwReason & 0x3FFFFFFF] / (float)dwIconHeight * KillConfig.Icon.IconSize * (float)desc.Height);
					pPVert[i * 4 + 1].x = pPVert[i * 4 + 3].x = (float)dwCurrentX;
					pPVert[i * 4 + 0].u = pPVert[i * 4 + 2].u = (float)((pLog[i].dwReason & 0x3FFFFFFF) % 8) / 8.f;
					pPVert[i * 4 + 1].u = pPVert[i * 4 + 3].u = ((float)((pLog[i].dwReason & 0x3FFFFFFF) % 8) + (float)KillConfig.IconWidth[pLog[i].dwReason & 0x3FFFFFFF] / (float)dwIconWidth) / 8.f;
					pPVert[i * 4 + 0].v = pPVert[i * 4 + 1].v = (float)((pLog[i].dwReason & 0x3FFFFFFF) / 8) / 8.f;
					pPVert[i * 4 + 2].v = pPVert[i * 4 + 3].v = (float)((pLog[i].dwReason & 0x3FFFFFFF) / 8 + 1) / 8.f;
					pD3DDev->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP, 2, &pPVert[i * 4], sizeof(PPVERT));
				}
				pPVert[i * 4 + 0].x = pPVert[i * 4 + 2].x = (float)dwCurrentX;
				dwCurrentX += (long)((float)KillConfig.IconWidth[pLog[i].dwReason & 0x3FFFFFFF] / (float)dwIconHeight * KillConfig.Icon.IconSize * (float)desc.Height);
				pPVert[i * 4 + 1].x = pPVert[i * 4 + 3].x = (float)dwCurrentX;
				pPVert[i * 4 + 0].u = pPVert[i * 4 + 2].u = (float)((pLog[i].dwReason & 0x3FFFFFFF) % 8) / 8.f;
				pPVert[i * 4 + 1].u = pPVert[i * 4 + 3].u = ((float)((pLog[i].dwReason & 0x3FFFFFFF) % 8) + (float)KillConfig.IconWidth[pLog[i].dwReason & 0x3FFFFFFF] / (float)dwIconWidth) / 8.f;
				pPVert[i * 4 + 0].v = pPVert[i * 4 + 1].v = (float)((pLog[i].dwReason & 0x3FFFFFFF) / 8) / 8.f;
				pPVert[i * 4 + 2].v = pPVert[i * 4 + 3].v = (float)((pLog[i].dwReason & 0x3FFFFFFF) / 8 + 1) / 8.f;
				pD3DDev->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP, 2, &pPVert[i * 4], sizeof(PPVERT));
				if (pLog[i].dwReason & 0x80000000)
				{
					pPVert[i * 4 + 0].x = pPVert[i * 4 + 2].x = (float)dwCurrentX;
					dwCurrentX += (long)((float)KillConfig.IconWidth[63] / (float)dwIconHeight * KillConfig.Icon.IconSize * (float)desc.Height);
					pPVert[i * 4 + 1].x = pPVert[i * 4 + 3].x = (float)dwCurrentX;
					pPVert[i * 4 + 0].u = pPVert[i * 4 + 2].u = 7.f / 8.f;
					pPVert[i * 4 + 1].u = pPVert[i * 4 + 3].u = (7.f + (float)KillConfig.IconWidth[63] / (float)dwIconWidth) / 8.f;
					pPVert[i * 4 + 0].v = pPVert[i * 4 + 1].v = 7.f / 8.f;
					pPVert[i * 4 + 2].v = pPVert[i * 4 + 3].v = 1.f;
					pD3DDev->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP, 2, &pPVert[i * 4], sizeof(PPVERT));
				}
				if (pLog[i].pVictim)
				{
					rect.left = rect.right = dwCurrentX;
					pLogFont->DrawText(NULL, pLog[i].pVictim, -1, &rect, DT_VCENTER | DT_SINGLELINE | DT_NOCLIP, pLog[i].dwVColor);
					rect.left = rect.right = 0;
					pLogFont->DrawText(NULL, pLog[i].pVictim, -1, &rect, DT_VCENTER | DT_SINGLELINE | DT_CALCRECT, pLog[i].dwVColor);
					dwCurrentX += rect.right;
				}
				if (pLog[i].pVictim && pLog[i].pVictim2)
				{
					dwCurrentX += desc.Width / 160;
					rect.left = rect.right = dwCurrentX;
					pLogFont->DrawText(NULL, "in", -1, &rect, DT_VCENTER | DT_SINGLELINE | DT_NOCLIP, 0xFFCCCCCC);
					rect.left = rect.right = 0;
					pLogFont->DrawText(NULL, "in", -1, &rect, DT_VCENTER | DT_SINGLELINE | DT_CALCRECT, 0xFFCCCCCC);
					dwCurrentX += rect.right;
					dwCurrentX += desc.Width / 160;
				}
				if (pLog[i].pVictim2)
				{
					rect.left = rect.right = dwCurrentX;
					pLogFont->DrawText(NULL, pLog[i].pVictim2, -1, &rect, DT_VCENTER | DT_SINGLELINE | DT_NOCLIP, pLog[i].dwVColor2);
					rect.left = rect.right = 0;
					pLogFont->DrawText(NULL, pLog[i].pVictim2, -1, &rect, DT_VCENTER | DT_SINGLELINE | DT_CALCRECT, pLog[i].dwVColor2);
					dwCurrentX += rect.right;
				}
				break;
			}
		case 1:
			{
				dwCurrentX = (long)(KillConfig.Position.PositionX * (float)desc.Width);
				if (pLog[i].pVictim2)
				{
					rect.left = rect.right = dwCurrentX;
					pLogFont->DrawText(NULL, pLog[i].pVictim2, -1, &rect, DT_RIGHT | DT_VCENTER | DT_SINGLELINE | DT_NOCLIP, pLog[i].dwVColor2);
					rect.left = rect.right = 0;
					pLogFont->DrawText(NULL, pLog[i].pVictim2, -1, &rect, DT_VCENTER | DT_SINGLELINE | DT_CALCRECT, pLog[i].dwVColor2);
					dwCurrentX -= rect.right;
				}
				if (pLog[i].pVictim && pLog[i].pVictim2)
				{
					dwCurrentX -= desc.Width / 160;
					rect.left = rect.right = dwCurrentX;
					pLogFont->DrawText(NULL, "in", -1, &rect, DT_RIGHT | DT_VCENTER | DT_SINGLELINE | DT_NOCLIP, 0xFFCCCCCC);
					rect.left = rect.right = 0;
					pLogFont->DrawText(NULL, "in", -1, &rect, DT_VCENTER | DT_SINGLELINE | DT_CALCRECT, 0xFFCCCCCC);
					dwCurrentX -= rect.right;
					dwCurrentX -= desc.Width / 160;
				}
				if (pLog[i].pVictim)
				{
					rect.left = rect.right = dwCurrentX;
					pLogFont->DrawText(NULL, pLog[i].pVictim, -1, &rect, DT_RIGHT | DT_VCENTER | DT_SINGLELINE | DT_NOCLIP, pLog[i].dwVColor);
					rect.left = rect.right = 0;
					pLogFont->DrawText(NULL, pLog[i].pVictim, -1, &rect, DT_VCENTER | DT_SINGLELINE | DT_CALCRECT, pLog[i].dwVColor);
					dwCurrentX -= rect.right;
				}
				if (pLog[i].dwReason & 0x80000000)
				{
					pPVert[i * 4 + 1].x = pPVert[i * 4 + 3].x = (float)dwCurrentX;
					dwCurrentX -= (long)((float)KillConfig.IconWidth[63] / (float)dwIconHeight * KillConfig.Icon.IconSize * (float)desc.Height);
					pPVert[i * 4 + 0].x = pPVert[i * 4 + 2].x = (float)dwCurrentX;
					pPVert[i * 4 + 0].u = pPVert[i * 4 + 2].u = 7.f / 8.f;
					pPVert[i * 4 + 1].u = pPVert[i * 4 + 3].u = (7.f + (float)KillConfig.IconWidth[63] / (float)dwIconWidth) / 8.f;
					pPVert[i * 4 + 0].v = pPVert[i * 4 + 1].v = 7.f / 8.f;
					pPVert[i * 4 + 2].v = pPVert[i * 4 + 3].v = 1.f;
					pD3DDev->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP, 2, &pPVert[i * 4], sizeof(PPVERT));
				}
				pPVert[i * 4 + 1].x = pPVert[i * 4 + 3].x = (float)dwCurrentX;
				dwCurrentX -= (long)((float)KillConfig.IconWidth[pLog[i].dwReason & 0x3FFFFFFF] / (float)dwIconHeight * KillConfig.Icon.IconSize * (float)desc.Height);
				pPVert[i * 4 + 0].x = pPVert[i * 4 + 2].x = (float)dwCurrentX;
				pPVert[i * 4 + 0].u = pPVert[i * 4 + 2].u = (float)((pLog[i].dwReason & 0x3FFFFFFF) % 8) / 8.f;
				pPVert[i * 4 + 1].u = pPVert[i * 4 + 3].u = ((float)((pLog[i].dwReason & 0x3FFFFFFF) % 8) + (float)KillConfig.IconWidth[pLog[i].dwReason & 0x3FFFFFFF] / (float)dwIconWidth) / 8.f;
				pPVert[i * 4 + 0].v = pPVert[i * 4 + 1].v = (float)((pLog[i].dwReason & 0x3FFFFFFF) / 8) / 8.f;
				pPVert[i * 4 + 2].v = pPVert[i * 4 + 3].v = (float)((pLog[i].dwReason & 0x3FFFFFFF) / 8 + 1) / 8.f;
				pD3DDev->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP, 2, &pPVert[i * 4], sizeof(PPVERT));
				if (pLog[i].dwReason & 0x40000000)
				{
					pPVert[i * 4 + 1].x = pPVert[i * 4 + 3].x = (float)dwCurrentX;
					dwCurrentX -= (long)((float)KillConfig.IconWidth[pLog[i].dwReason & 0x3FFFFFFF] / (float)dwIconHeight * KillConfig.Icon.IconSize * (float)desc.Height);
					pPVert[i * 4 + 0].x = pPVert[i * 4 + 2].x = (float)dwCurrentX;
					pPVert[i * 4 + 0].u = pPVert[i * 4 + 2].u = (float)((pLog[i].dwReason & 0x3FFFFFFF) % 8) / 8.f;
					pPVert[i * 4 + 1].u = pPVert[i * 4 + 3].u = ((float)((pLog[i].dwReason & 0x3FFFFFFF) % 8) + (float)KillConfig.IconWidth[pLog[i].dwReason & 0x3FFFFFFF] / (float)dwIconWidth) / 8.f;
					pPVert[i * 4 + 0].v = pPVert[i * 4 + 1].v = (float)((pLog[i].dwReason & 0x3FFFFFFF) / 8) / 8.f;
					pPVert[i * 4 + 2].v = pPVert[i * 4 + 3].v = (float)((pLog[i].dwReason & 0x3FFFFFFF) / 8 + 1) / 8.f;
					pD3DDev->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP, 2, &pPVert[i * 4], sizeof(PPVERT));
				}
				if (pLog[i].pKiller2)
				{
					rect.left = rect.right = dwCurrentX;
					pLogFont->DrawText(NULL, pLog[i].pKiller2, -1, &rect, DT_RIGHT | DT_VCENTER | DT_SINGLELINE | DT_NOCLIP, pLog[i].dwKColor2);
					rect.left = rect.right = 0;
					pLogFont->DrawText(NULL, pLog[i].pKiller2, -1, &rect, DT_VCENTER | DT_SINGLELINE | DT_CALCRECT, pLog[i].dwKColor2);
					dwCurrentX -= rect.right;
				}
				if (pLog[i].pKiller && pLog[i].pKiller2)
				{
					dwCurrentX -= desc.Width / 160;
					rect.left = rect.right = dwCurrentX;
					pLogFont->DrawText(NULL, "in", -1, &rect, DT_RIGHT | DT_VCENTER | DT_SINGLELINE | DT_NOCLIP, 0xFFCCCCCC);
					rect.left = rect.right = 0;
					pLogFont->DrawText(NULL, "in", -1, &rect, DT_VCENTER | DT_SINGLELINE | DT_CALCRECT, 0xFFCCCCCC);
					dwCurrentX -= rect.right;
					dwCurrentX -= desc.Width / 160;
				}
				if (pLog[i].pKiller)
				{
					rect.left = rect.right = dwCurrentX;
					pLogFont->DrawText(NULL, pLog[i].pKiller, -1, &rect, DT_RIGHT | DT_VCENTER | DT_SINGLELINE | DT_NOCLIP, pLog[i].dwKColor);
					rect.left = rect.right = 0;
					pLogFont->DrawText(NULL, pLog[i].pKiller, -1, &rect, DT_VCENTER | DT_SINGLELINE | DT_CALCRECT, pLog[i].dwKColor);
					dwCurrentX -= rect.right;
				}
				break;
			}
		}
	}

	pD3DDev->SetRenderTarget(0, pOldRTarget);
	pD3DDev->SetTexture(0, pOldTexture);
	pD3DDev->SetFVF(dwFVF);
    pD3DDev->SetVertexDeclaration(pVDecl);
	pD3DDev->SetRenderState(D3DRS_ZENABLE, dwZEnable);
	pD3DDev->SetRenderState(D3DRS_ZWRITEENABLE, dwZWrite);
	pD3DDev->SetRenderState(D3DRS_SRCBLEND, dwSBlend);
	pD3DDev->SetRenderState(D3DRS_DESTBLEND, dwDBlend);
	pD3DDev->SetRenderState(D3DRS_CULLMODE, dwCull);
	pD3DDev->SetRenderState(D3DRS_ZFUNC, dwZFunc);
	pD3DDev->SetRenderState(D3DRS_BLENDOP, dwBlendOp);
	pD3DDev->SetStreamSource(0, pSSData, dwSSOffset, dwSSSize);
	pD3DDev->SetSamplerState(0, D3DSAMP_MAGFILTER, tfMag);
	pD3DDev->SetSamplerState(0, D3DSAMP_MINFILTER, tfMin);
	pD3DDev->SetSamplerState(0, D3DSAMP_MIPFILTER, tfMip);
	pD3DDev->SetSamplerState(0, D3DSAMP_ADDRESSU, ssAdU);
	pD3DDev->SetSamplerState(0, D3DSAMP_ADDRESSV, ssAdV);

	SAFE_RELEASE(pOldRTarget);
	SAFE_RELEASE(pOldTexture);
	SAFE_RELEASE(pVDecl);
	SAFE_RELEASE(pSSData);

	if (dwRenderCall) ((char (*)())dwRenderCall)();
	return *(char*)0xC402CC;
}

void __declspec(naked) HeadShot()
{
	__asm
	{
		cmp [edi+9], 0;
		jz NON_HEAD;
		mov edx, 0xB74490;
		mov edx, [edx];
		mov edx, [edx];
		sub edx, esi;
		imul edx, -1;
		mov eax, 0x41EE7CA7;
		imul edx;
		sar edx, 0x9;
		mov eax, edx;
		shr eax, 0x1F;
		add edx, eax;
		mov eax, dword ptr [pPHead];
		mov byte ptr [eax+edx], 1;
NON_HEAD:
		mov dword ptr [esi+0x540], 0;
		push 0x4B339B;
		ret;
	}
}

void GetKiller(LOG* pLogI, void* pEntity)
{
	if (!pEntity) return;
	if ((*((unsigned char*)pEntity + 0x36) & 0x07) == 2)
	{
		switch (KillConfig.NameConv.KVehicle)
		{
		case 0:
			pLogI->pKiller = ((char* (__fastcall *)(long, void*, char*))0x6A0050)(0xC1B340, NULL, ((char**)0xA9B0C8)[((unsigned short*)pEntity)[0x11]] + 50);
			pLogI->dwKColor = ((unsigned long*)0xB4E480)[((unsigned char*)pEntity)[0x434]];
			((unsigned char*)&pLogI->dwKColor)[0] ^= ((unsigned char*)&pLogI->dwKColor)[2];
			((unsigned char*)&pLogI->dwKColor)[2] ^= ((unsigned char*)&pLogI->dwKColor)[0];
			((unsigned char*)&pLogI->dwKColor)[0] ^= ((unsigned char*)&pLogI->dwKColor)[2];
			break;
		case 1:
			if (((unsigned long*)pEntity)[0x118]) GetPedName(((unsigned long**)pEntity)[0x118][0x166], ((unsigned short**)pEntity)[0x118][0x11], &pLogI->pKiller, &pLogI->dwKColor);
			break;
		case 2:
			if (((unsigned long*)pEntity)[0x118]) GetPedName(((unsigned long**)pEntity)[0x118][0x166], ((unsigned short**)pEntity)[0x118][0x11], &pLogI->pKiller, &pLogI->dwKColor);
			if (!((unsigned long*)pEntity)[0x118]) pLogI->pKiller = ((char* (__fastcall *)(long, void*, char*))0x6A0050)(0xC1B340, NULL, ((char**)0xA9B0C8)[((unsigned short*)pEntity)[0x11]] + 50);
			if (!((unsigned long*)pEntity)[0x118]) pLogI->dwKColor = ((unsigned long*)0xB4E480)[((unsigned char*)pEntity)[0x434]];
			break;
		case 3:
			if (((unsigned long*)pEntity)[0x118]) GetPedName(((unsigned long**)pEntity)[0x118][0x166], ((unsigned short**)pEntity)[0x118][0x11], &pLogI->pKiller, &pLogI->dwKColor);
			pLogI->pKiller2 = ((char* (__fastcall *)(long, void*, char*))0x6A0050)(0xC1B340, NULL, ((char**)0xA9B0C8)[((unsigned short*)pEntity)[0x11]] + 50);
			pLogI->dwKColor2 = ((unsigned long*)0xB4E480)[((unsigned char*)pEntity)[0x434]];
			((unsigned char*)&pLogI->dwKColor2)[0] ^= ((unsigned char*)&pLogI->dwKColor2)[2];
			((unsigned char*)&pLogI->dwKColor2)[2] ^= ((unsigned char*)&pLogI->dwKColor2)[0];
			((unsigned char*)&pLogI->dwKColor2)[0] ^= ((unsigned char*)&pLogI->dwKColor2)[2];
			break;
		case 4:
			break;
		}
	}
	if ((*((unsigned char*)pEntity + 0x36) & 0x07) == 3)
	{
		GetPedName(((unsigned long*)pEntity)[0x166], ((unsigned short*)pEntity)[0x11], &pLogI->pKiller, &pLogI->dwKColor);
		if (KillConfig.NameConv.KDriver) if (((unsigned long*)pEntity)[0x14C] == 50) if (((unsigned long*)pEntity)[0x163])
		{
			pLogI->pKiller2 = ((char* (__fastcall *)(long, void*, char*))0x6A0050)(0xC1B340, NULL, ((char**)0xA9B0C8)[((unsigned short**)pEntity)[0x163][0x11]] + 50);
			pLogI->dwKColor2 = ((unsigned long*)0xB4E480)[((unsigned char**)pEntity)[0x163][0x434]];
			((unsigned char*)&pLogI->dwKColor2)[0] ^= ((unsigned char*)&pLogI->dwKColor2)[2];
			((unsigned char*)&pLogI->dwKColor2)[2] ^= ((unsigned char*)&pLogI->dwKColor2)[0];
			((unsigned char*)&pLogI->dwKColor2)[0] ^= ((unsigned char*)&pLogI->dwKColor2)[2];
		}
		if (_GetWeaponData(pLogI->dwReason & 0x3FFFFFFF, _GetWeaponSkill(pEntity, NULL, pLogI->dwReason & 0x3FFFFFFF))) if (_GetWeaponData(pLogI->dwReason & 0x3FFFFFFF, _GetWeaponSkill(pEntity, NULL, pLogI->dwReason & 0x3FFFFFFF))[6] & 0x0800) pLogI->dwReason |= 0x40000000;
		if (_GetWeaponData(pLogI->dwReason & 0x3FFFFFFF, _GetWeaponSkill(pEntity, NULL, pLogI->dwReason & 0x3FFFFFFF))) if (_GetWeaponData(pLogI->dwReason & 0x3FFFFFFF, _GetWeaponSkill(pEntity, NULL, pLogI->dwReason & 0x3FFFFFFF))[0] != 1) pLogI->dwReason &= 0x7FFFFFFF;
		if (!_GetWeaponData(pLogI->dwReason & 0x3FFFFFFF, _GetWeaponSkill(pEntity, NULL, pLogI->dwReason & 0x3FFFFFFF))) pLogI->dwReason &= 0x7FFFFFFF;
	}
}

void GetPedName(int type, int model, char** name, unsigned long* color)
{
	for (int i = 0; i < KillConfig.NameRuleNum; i++)
	{
		if (KillConfig.NameRule[i].PedType != -1) if (KillConfig.NameRule[i].PedType != type) continue;
		if (KillConfig.NameRule[i].ModelID != -1) if (KillConfig.NameRule[i].ModelID != model && KillConfig.NameRule[i].ModelID != ((int**)0xA9B0C8)[model][1]) continue;
		if (KillConfig.NameRule[i].Color) *color = KillConfig.NameRule[i].Color;
		if (strlen(KillConfig.NameRule[i].Name)) *name = KillConfig.NameRule[i].Name;
	}
	return;
}

unsigned long crc_table[256];
int crc_table_computed = 0;

void make_crc_table()
{
	unsigned long c;
	int n, k;
	for (n = 0; n < 256; n++)
	{
		c = (unsigned long)n;
		for (k = 0; k < 8; k++)
		{
			if (c & 1) c = 0xedb88320L ^ (c >> 1);
			else c = c >> 1;
		}
		crc_table[n] = c;
	}
	crc_table_computed = 1;
}

int update_crc(unsigned long crc, char* buf, int len)
{
	unsigned long c = crc;
	int n;
	if (!crc_table_computed) make_crc_table();
	for (n = 0; n < len; n++) c = crc_table[(c ^ buf[n]) & 0xff] ^ (c >> 8);
	return c;
}

int crc(char* buf, int len)
{
	return update_crc(0xffffffffL, buf, len) ^ 0xffffffffL;
}
