#define WIN32_LEAN_AND_MEAN
#include <windows.h>

#include <stdio.h>
#include <stdlib.h>

#include <d3dx9.h>
#pragma comment(lib, "d3d9.lib")
#ifdef _DEBUG
#pragma comment(lib, "d3dx9d.lib")
#else
#pragma comment(lib, "d3dx9.lib")
#endif


enum KILLSTATE
{
	KS_NOTUSED,
	KS_ALIVE,
	KS_DEAD
};

struct NAMERULE
{
	int PedType;
	int ModelID;
	unsigned long Color;
	char* Name;
};

struct KLCONFIG
{
	struct KILLLOG
	{
		int Suicide;
		int MaxLog;
		unsigned int LogTime;
		int ShowPedDeath;
		int ShowVehicleDeath;
		char NameConfig[MAX_PATH];
		char IconConfig[MAX_PATH];
	} KillLog;
	struct FONT
	{
		int FontSize;
		int FontWeight;
		char FontFace[64];
	} Font;
	struct POSITION
	{
		float PositionX;
		float PositionY;
		float Height;
		int AlignH;
		int AlignV;
	} Position;
	struct ICON
	{
		char IconFile[MAX_PATH];
		D3DBLEND IconSBlend;
		D3DBLEND IconDBlend;
		D3DBLENDOP IconBlendO;
		float IconSize;
	} Icon;
	struct NAMECONV
	{
		int KDriver;
		int KVehicle;
		int VDriver;
		int VVehicle;
	} NameConv;
	int IconWidth[64];
	int NameRuleNum;
	NAMERULE* NameRule;
	char* NameRuleString;
} KillConfig;

struct LOG
{
	char* pKiller;
	unsigned long dwKColor;
	char* pKiller2;
	unsigned long dwKColor2;
	char* pVictim;
	unsigned long dwVColor;
	char* pVictim2;
	unsigned long dwVColor2;
	unsigned long dwReason;
	unsigned long dwTime;
};

IDirect3DTexture9* pIconTexture;
unsigned long dwIconWidth;
unsigned long dwIconHeight;
ID3DXFont* pLogFont;

struct PPVERT
{
    float x, y, z, w;
	DWORD c;
    float u, v;
};


BOOL APIENTRY DllMain(HMODULE, DWORD, LPVOID);

void DLLInit();
void DLLExit();

void InitResource();
void DestResource();

void Change3D();
long dwChange3DCall = NULL;

void Reset3D();
long dwReset3DCall = NULL;

char Render();
long dwRenderCall = NULL;
void HeadShot();

void GetKiller(LOG*, void*);
void GetPedName(int, int, char**, unsigned long*);

int crc(char* buf, int len);


char (__fastcall *_GetWeaponSkill)(void*, void*, long) = (char (__fastcall *)(void*, void*, long))0x5E3B60;
long* (__cdecl *_GetWeaponData)(long, char) = (long* (__cdecl *)(long, char))0x743C60;


#define SAFE_RELEASE(p) {if(p){(p)->Release();(p)=NULL;}}
#define SAFE_DELETE(p) {if(p){delete (p);(p)=NULL;}}
#define SAFE_FREE(p) {if(p){free(p);(p)=NULL;}}

#define patch(a, v, s) _patch((void*)(a), (void*)(v), (s))
void _patch(void*, void*, int);
#define nop(a, s) _nop((void*)(a), (s))
void _nop(void*, int);
bool check(void*, unsigned char, const char*, bool);
bool _check(void*, unsigned char);

void _patch(void* pAddress, void* pData, int iSize)
{
	unsigned long dwProtect[2];
	VirtualProtect(pAddress, iSize, PAGE_EXECUTE_READWRITE, &dwProtect[0]);
	memcpy(pAddress, pData, iSize);
	VirtualProtect(pAddress, iSize, dwProtect[0], &dwProtect[1]);
}

void _nop(void* pAddress, int iSize)
{
	unsigned long dwProtect[2];
	VirtualProtect(pAddress, iSize, PAGE_EXECUTE_READWRITE, &dwProtect[0]);
	memset(pAddress, 0x90, iSize);
	VirtualProtect(pAddress, iSize, dwProtect[0], &dwProtect[1]);
}

bool check(void* pAddress, unsigned char cByte, const char* sExp, bool bContinue)
{
	if (_check(pAddress, cByte)) return true;
	if (bContinue) return false;
	char buf[1024];
	sprintf_s(buf, 1024, "An unknown code found at 0x%08X (%s).\nDo you want to continue without this Function?", pAddress, sExp);
	if (MessageBox(0, buf, "HUD", MB_YESNO | MB_ICONERROR | MB_DEFBUTTON2) == IDNO) ExitProcess(0);
	return false;
}

bool _check(void* pAddress, unsigned char cByte)
{
	unsigned long dwProtect[2];
	unsigned char cValue = cByte;
	VirtualProtect(pAddress, 1, PAGE_EXECUTE_READ, &dwProtect[0]);
	memcpy(&cValue, pAddress, 1);
	VirtualProtect(pAddress, 1, dwProtect[0], &dwProtect[1]);
	return (cValue == cByte);
}
